#include "mirorer.h"
#include <map>




template<class T>
T Cast(const std::string&s)
{
  std::istringstream is(s);
  T res;
  is >> res;
  return res;
}


template<class T>
void PutNeedle(vector3d<T> &vec, int provod, int neprovod)
{
  double x = 75+43; // 118
  double y = 75+132; // 208
  double z = 75+35; //110
  int i, j, k;

  y -= 16;
  x -= 1;
  i = (x+0.5*vec.dim[0])/vec.dim[0];
  j = (y+0.5*vec.dim[1])/vec.dim[1] + 2;
  k = (z+0.5*vec.dim[2])/vec.dim[2];
  for (int I = 0;I <15; ++I,j--)
  {
    vec(i,j,k) = provod;
    vec(i+1,j,k) = provod;
  }
  ++j;
  for (;j--;)
  {
    vec(i,j,k) = neprovod;
    vec(i+1,j,k) = neprovod;
  }
    
  std::cout << vec.dim[0] << " " << vec.dim[1] << " " << vec.dim[2] << std::endl;
  return (void)(i+j+k);
}



int main(int argc, char **argv)
{
  if (argc <4)
    return 1;
  std::string fname = argv[1];
  typedef std::map<int, int> map_t;
  typedef map_t::iterator iter;
  map_t map;
  argc--;
  int max = 0;
  for (int i = 2; i <argc; i+=2)
  {
    int a = Cast<int>(argv[i+1]);
    map[Cast<int>(argv[i])] = a;
    if (a>=max)
      max = a;
  }
  vector3d<unsigned char> in, out;
  in.ReadInr(fname);
  out.SetSize(in);
  for (size_t i = in.sizes[0]; i--;)
    for (size_t j = in.sizes[1]; j--;)
      for (size_t k = in.sizes[2]; k--;)
      {
	iter iter = map.find(in(i,j,k));
	if (iter!=map.end())
	  out(i,j,k) = iter->second;
	else
	  out(i,j,k) = 0;
      }
  max = 0;
  PutNeedle(out, max+1, max+2);
  out.WriteInr("out"+fname);
}
