#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <iomanip>
#include "mirorer.h"


int main(int argc, char **argv)
{
  if (argc != 2)
    return -1;
  using namespace std;
  string fname = argv[1];


  vector3d<unsigned char> vec;
  vector3d<unsigned char>vec1;
  vec.ReadInr(fname);
  int N1 = vec.sizes[0];
  int N2 = vec.sizes[1];
  int N3 = vec.sizes[2];
  double d1 = vec.dim[0];
  double d2 = vec.dim[1];
  double d3 = vec.dim[2];
  N1 &= ~1;
  N2 &= ~1;
  N3 &= ~1;
  assert(!(N1 &1));
  assert(!(N2 &1));
  assert(!(N3 &1));

  int M1, M2, M3;
  M1 = (N1+1)/2;
  M2 = (N2+1)/2;
  M3 = (N3+1)/2;
  
  vec1.SetSize(M1, M2, M3,
	       d1*2, d2*2, d3*2);
  for(int k = 0; k < M3; ++k)
    for(int i = 0; i < M1; ++i)
      for(int j = 0; j < M2; ++j)
	vec1(i,j,k) = 0;
  
  for(int k = 0; k < N3-1; k+=2)
  {
    std::cout <<std::setw(4) << (double)k/(N1-1)*100 
	      << "\r" << std::flush;// std::endl;
    for(int i = 0; i < N1-1; i+=2)
      for(int j = 0; j < N2-1; j+=2)
      {

	static std::vector<unsigned char> buf;
	buf.clear();
	int sum =0;
	for (int I = 0; I < 2; ++I)
	  for (int J = 0; J < 2; ++J)
	    for (int K = 0; K < 2; ++K)
	      sum +=vec(i+I,j+J,k+K);
	//	      buf.push_back(vec(i+I,j+J,k+K));
	//	std::sort(buf.begin(), buf.end());
	//	sum += buf[5];//+buf[4]+1;
	//	sum >>=1; //;
	sum >>=3; // /8
	vec1(i>>1, j >>1, k>>1) = sum;
      }
  }

  ostringstream fn;
  fn << N1/2 << "x"
    << N2/2 << "x"
    << N3/2 << "."
     << fname;
  vec1.WriteInr(fn.str());
  return 0;
}
	  
    
  
