#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <cmath>

#include "mirorer.h"


int main(int argc, char **argv)
{
  if (argc != 2)
    return -1;
  using namespace std;
  string fname = argv[1];
  int N;
  {
    istringstream is(argv[1]);
    is >> N;
  }
  ifstream f(fname.c_str());

  vector3d<unsigned char> vec;
  vec.SetSize(N, N, N, 1./N, 1./N, 1./N);

  int plates = 16;
  int num = N/plates;
  int num2 = num/2;
  
  for(int i = 0; i <N; ++i)
    for(int j = 0; j <N; ++j)
      for(int k = 0; k < N; ++k)
      {
	bool write = false;
	bool n1, n2, n3;
	n1 = false;
	n2 = false;
	n3 = false;
	n1 = i&1;
	int real = j*16;
	n2 = (j%num)<num2;
	n3 = k&1;
	//	write = n1 || n2 || n3;
	write = n2 &n1;// || n2 || n3;
	vec(i,j,k)=(write)?255:0;
	  
      }
  ostringstream fn;
  fn << N << "." << "inr";
  vec.ConvertAllTo(1);
  //  vec.RemoveBad(20);
  vec.ConvertAllTo(255);  
 
  vec.WriteInr(fn.str());
  return 0;
}
	  
    
  
