#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include "math.h"
#include "mirorer.h"


int main(int argc, char **argv)
{
  if (argc != 3)
    return -1;
  using namespace std;
  string fname = argv[1];
  int N;
  {
    istringstream is(argv[1]);
    is >> N;
  }

  vector3d<double> vec;
  vector3d<double>vec1;
  vec.SetSize(N, N, N);
  vec1.SetSize(N, N, N);
  vec.Read(fname, 0);
  vec1.Read(argv[2], 0);
  double diff = 0;
  for(int k = 0; k < N; ++k)
    for(int i = 0; i < N; ++i)
      for(int j = 0; j < N; ++j)
      {
	double d = vec1(i,j,k)  -vec(i,j,k);
	d = fabs(d);
	if (d > diff)
	  diff = d;
      }
  
  std::cout << "Max diff = " << diff <<endl;
  return 0;
}
	  
    
  
