#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include "math.h"
#include "mirorer.h"
#include <limits>

int main(int argc, char **argv)
{
  if (argc != 2)
    return -1;
  using namespace std;
  string fname = argv[1];
  int N;
  {
    istringstream is(argv[1]);
    is >> N;
  }

  vector3d<double> vec;
  vec.SetSize(N, N, N);
  vec.Read(fname, 0);
  double mn, mx;
  mn = numeric_limits<double>::max();
  mx = - mn;
  for(int k = 0; k < N; ++k)
    for(int i = 0; i < N; ++i)
      for(int j = 0; j < N; ++j)
      {
	double d = vec(i,j,k);
	if (d >mx)
	  mx = d;
	if (d <mn)
	  mn = d;
      }
  
  std::cout <<"Min = " << mn <<  ";    Max  = " << mx <<endl;
  return 0;
}
	  
    
  
