#include <iostream>
#include <string>
#include <sstream>
#include "mirorer.h"


int main(int argc, char **argv)
{
  std::string filename = "default";
  if (argc >1)
    filename = argv[1];
  std::istringstream is(filename);
  int sz;
  is >> sz;
  std::cout << "size is " << sz << std::endl;
  vector3d<unsigned char > vec;

  std::ostringstream os;
  os << sz*2 <<".d.bonec";
  
  vec.SetSize(sz,sz,sz);
  vec.Read(filename, 0);
  Mirror(vec, 2)->Write(os.str());
  //  std::cout << "written " << (double)nzcount/sz1/sz2/sz3 << std::endl;
}
