#include <iostream>
#include <fstream>
#include <string>
#include <sstream>

#include "mirorer.h"


int main(int argc, char **argv)
{
  if (argc != 2)
    return -1;
  using namespace std;
  string fname = argv[1];
  int N;
  {
    istringstream is(argv[1]);
    is >> N;
  }

  vector3d<unsigned char> vec;
  vec.ReadInr(fname);

  int o0, o1, o2;
  o0 = 1; o1 = 2; o2 = 0;

  double (&dim)[3] = vec.dim;
  size_t (&sizes)[3] = vec.sizes;
  
  
  vector3d<unsigned char>vec1;
  vec1.SetSize(sizes[o0], sizes[o1], sizes[o2],
	  dim[o0], dim[o1], dim[o2]);
  for(int k = 0; k < vec.sizes[0]; ++k)
    for(int i = 0; i < vec.sizes[1]; ++i)
      for(int j = 0; j < vec.sizes[2]; ++j)
      {
	int mas[] = {i,j,k};
	vec1(mas[o0], mas[o1], mas[o2]) = vec(i,j,k);
      }
  
  ostringstream fn;
  fn << "t" << fname << ".inr" ;
  vec1.WriteInr(fn.str());
  return 0;
}
	  
    
  
