#include <iostream>
#include <vector>		
#include <algorithm>
#include <iterator>
#include "mirorer.h"

std::vector<int>  thres;



unsigned char Get(int a)
{
  std::vector<int>::iterator iter;
  iter = lower_bound(thres.begin(), thres.end(), a);
  unsigned char ret = static_cast<unsigned char>(std::distance(thres.begin(), iter));
  return ret;
}

int main(int argc, char **argv)
{

  const int N1=231;
  const int N2=231;
  const int N3=37;

  if (argc<2)
    return 1;
  std::string fname = argv[1];


  thres.push_back(-1000);
  thres.push_back(-717);
  thres.push_back(-433);
  thres.push_back(-150);
  
  vector3d<signed short int> vec;
  assert(sizeof(signed short int)==2);

  double dim=75.e-3;
  
  vector3d<unsigned char>vec1;
  vec.SetSize(N1, N2, N3, dim, dim, dim);
  vec.Read(fname, 0);
  vec1.SetSize(N1, N3, N2, dim, dim, dim);
  for(int k = 0; k < N3; ++k)
    for(int i = 0; i < N1; ++i)
      for(int j = 0; j < N2; ++j)
      {
	vec1(i,k,j) = Get(vec(i, j, k));
      }
  vec1.WriteInr(fname +".inr");
  return 0;
}
