#include "solver.hpp"
#ifndef USE_EXPORT
namespace{
  typedef SmallVector<double, 3> Dpoint_type;
  typedef BDom<Dpoint_type, int> Dbvector_type;
  typedef SmallVector<float, 3> Fpoint_type;
  typedef BDom<Fpoint_type, int> Fbvector_type;
}


template class Projection<Dbvector_type>;
template class Projection<BDom<double, int> >;

//template class PDom<Dbvector_type>;


template class PCGSolverBase<BDom<double, int> >;

template class PCGSolverBase<Dbvector_type >;

template class PCGSolver<BDom<double, int> >;

template class PCGSolver<Dbvector_type >;


template class GPCGSolver<BDom<double, int> >;

template class GPCGSolver<Dbvector_type >;


#ifdef _FLOAT_EXPAND
template class Projection<BDom<float, int> >;
template class Projection<Fbvector_type >;
template class PDom<Fbvector_type >;

template class PCGSolverBase<BDom<float, int> >;

template class PCGSolverBase<Fbvector_type>;

template class PCGSolver<BDom<float, int> >;

template class PCGSolver<Fbvector_type>;

template class GPCGSolver<BDom<float, int> >;

template class GPCGSolver<Fbvector_type>;



#endif

#endif //export
// some explicit specifications
