#ifndef __cg_hpp__
#define __cg_hpp__

#include "cg.h"
#include <iostream>
#include <iomanip>
#include <sstream>

#include "functors.h"
#include "visitors.h"


// //#pragma implementation
// template<class Double, class Int>
// unsigned  Worker<Double, Int>::CG(
// 				  const matrix_type &Mat,
// 				  bvector_type &X,
// 				  const bvector_type &RHS,
// 				  Double Eps,
// 				  Index3dBase<Int> &ind)
// {
//   algname += " CG";
//   typedef bvector_type XType;

//   Eps *= Eps;
//   typedef matrix_type Matrix;
//   typedef bvector_type XType;
//   typedef bvector_type RHSType;
//   typedef typename XType::BType DType;
//   typedef typename XType::BType GType;
//   typedef typename XType::BType HdType;  

//   DType D(X.N1, X.N2, X.N3, X.N3R);
//   D.CreateDatatypes();
//   D.SetComm(comm);
//   GType G(X.N1, X.N2, X.N3, X.N3R);
//   HdType Hd(X.N1, X.N2, X.N3, X.N3R);
//   Double gtg, gtgold, tau, beta, gtgfull;
//   Double temp, temp1;
  
//   MultiplyMatVector<Matrix, DType, HdType> MulHd(Mat, D, Hd);
  
//   VecDot<GType, GType> GtG(G, G);
//   VecDot<DType, HdType> DtHd(D, Hd);
 

//   //  PrintFunctor<const matrix_type > printmat(Mat);
//   //  Execute<ForAllColumnwise>(ind, printmat, size, rank);
//   //  return 0;

  
//   {
//     VecCpy<DType, XType> Cpy(D, X);
//     Execute<ForAll>(ind, Cpy, size, rank);
//   }

//   //  TestFunctor<Int> Test;
//   //  Execute<ForAllColumnwise>(ind, Test, size, rank);
//   //  if (rank == 0)
//   //      cout << rank << " Count is " << Test.Count << endl;
//   //  InitFunctor<DType> IF(D);
//   //  PrintFunctor<DType>PF(D);
//   //  Execute<ForAllColumnwise>(ind, IF, size, rank);
//   //  if(rank == 1)Execute<ForAllColumnwiseReverse>(ind, PF, size, rank);
//   //  return 0;
//   //  Execute<ForAll>(ind, MulHd, size, rank);
//   ClearVector(Hd);
//   D.StartSendRecv();
//   ForAllMiddle(ind, MulHd); // Hd = Ad
//   D.FinishSendRecv();

//   ForAllNonMiddle(ind, MulHd);
//   //Execute<ForAll>(ind, MulHd, size, rank);
  
//   /*         { */
//   /*     VecDot<HdType, HdType> dt(Hd, Hd); */
//   /*     Execute<ForAll>(ind, dt, size, rank); */
//   /*     std::cout << dt.GetSum() << std::endl; */
//   /*     //    return 0; */
//   /*     } */

//   {
//     VecCpy<GType, HdType> Cpy(G, Hd);
//     Execute<ForAll>(ind, Cpy, size, rank); // G = Hd;
//     VecSub<GType, RHSType> vsub(G, RHS);
//     Execute<ForAll>(ind, vsub, size, rank);// G -= RHS;
//   }

  
//   ClearVector(D); // D = 0;
  
//   {
//     VecSub<DType, GType> vsub(D, G);
//     Execute<ForAll>(ind, vsub, size, rank); // D = -G;
//   }



  
//   Execute<ForAll>(ind, GtG, size, rank);
//   temp = GtG.GetSum(); // GtG

//   using namespace std;

//   comm.Allreduce(&temp, &gtg, 1, Myf<Double>::Datatype(), MPI::SUM);

//   gtgfull = gtg;  


//   unsigned iter = 0;
//   D.StartSendRecv();
//   {
//     TimeCalc(comptimesystemsolveiterations);
//     while (gtg > Eps*gtgfull)
//     {	  
//       gtgold = gtg;
//       //		  std::cout << iter << " " <<gtgold <<std::endl;
//       if(iter >20024)
// 	break;
//       // Hd = A.D
//       {
// 	TimeCalc(comptimematvec);
// 	ClearVector(Hd);
// 	ForAllMiddle(ind, MulHd);
//       }
//       {
// 	TimeCalc(commtimematvec);
// 	D.FinishSendRecv();
//       }
//       {
// 	TimeCalc(comptimematvec);
// 	ForAllNonMiddle(ind, MulHd);
// 	//Execute<ForAll>(ind, MulHd, size, rank);
//       }
		  
//       // Dt.Hd
//       {
// 	TimeCalc(comptimevecdot);
// 	Execute<ForAll>(ind, DtHd, size, rank); 
//       }
//       {
// 	TimeCalc(commtimevecdot);
// 	temp = DtHd.GetSum();
// 	comm.Allreduce(&temp, &temp1, 1, 
// 		       Myf<Double>::Datatype(), MPI::SUM);

//       }
		  
		  
//       tau = gtg/temp1;
//       // x += d*tau;
//       // g += Hd*tau;
//       {
// 	TimeCalc(comptimevecvec);
// 	VecUpdate<XType, DType> vecu1(X, D, tau);
// 	Execute<ForAll>(ind, vecu1, size, rank); // x += d*tau
// 	VecUpdate<GType, HdType> vecu2(G, Hd, tau);
// 	Execute<ForAll>(ind, vecu2, size, rank); // g+= Hd*tau;
// 	/*	      DualFunctor<VecUpdate<XType, DType>, VecUpdate<GType, HdType> > dual = MakeDualFunctor(vecu1, vecu2);
// 		      DualFunctor<DualFunctor<VecUpdate<XType, DType>, VecUpdate<GType, HdType> >,    VecDot<GType, GType> > tripyl = MakeDualFunctor(dual, GtG);
// 		      Execute<ForAll>(ind, tripyl, size, rank);
// 	*/
//       }
//       // G.G
//       {
// 	TimeCalc(comptimevecdot);
// 	Execute<ForAll>(ind, GtG, size, rank); 
//       }
//       {
// 	TimeCalc(commtimevecdot);
// 	temp = GtG.GetSum(); // GtG
// 	comm.Allreduce(&temp, &gtg, 1, 
// 		       Myf<Double>::Datatype(), MPI::SUM);
// 	//			  cout << temp << " " << gtg << endl;
//       }
//       beta = gtg/gtgold;
		  
//       // d = beta *d -g
//       {
// 	VecUpdate2<DType, GType> vecu(D, G, beta);
// 	{
// 	  TimeCalc(comptimevecvec);
// 	  //Execute<ForAll>(ind, vecu, size, rank); // d = beta*d - g 
// 	  ForAllNonMiddle(ind, vecu);
// 	}
// 	{
// 	  TimeCalc(commtimematvec);
// 	  D.StartSendRecv();
// 	}
// 	{
// 	  TimeCalc(comptimevecvec);
// 	  ForAllMiddle(ind, vecu);
// 	}
//       }
//       ++iter;
//     }
//   }
//   D.FinishSendRecv();
//   return iter;     
// }

// template<class Double, class Int>
// template<class PreconMethod>
// unsigned Worker<Double, Int>::PCG(
// 				  const matrix_type &Mat,
// 				  bvector_type &X,
// 				  bvector_type &RHS,
// 				  Double Eps,
// 				  Index3dBase<Int> &ind)
// {
//   typedef bvector_type XType;
//   algname += " PCG" + PreconMethod::name();
//   Eps *= Eps;
//   typedef matrix_type Matrix;
//   typedef bvector_type XType;
//   typedef bvector_type RHSType;
//   typedef typename XType::BType DType;
//   typedef typename XType::BType GType;
//   typedef typename XType::BType HdType;  
//   typedef typename XType::BType PType;
  
  
//   PType P(X.N1, X.N2, X.N3, X.N3R);
//   P.SetComm(comm);
//   P.CreateDatatypes();
//   DType D(X.N1, X.N2, X.N3, X.N3R);
//   D.SetComm(comm);
//   D.CreateDatatypes();
//   GType G(X.N1, X.N2, X.N3, X.N3R);
//   HdType Hd(X.N1, X.N2, X.N3, X.N3R);
//   Hd.SetComm(comm);
//   //  HdType &h = RHS;
//   HdType h(X.N1, X.N2, X.N3, X.N3R);
//   h.SetComm(comm);
//   h.CreateDatatypes();
//   Hd.CreateDatatypes();
//   Double gtg, gtgold, tau, beta, gtgfull, temp, temp1;
  

//   PreconCreatorStep1<Matrix, PType, PreconMethod> st1(Mat, P);
//   PreconCreatorStep1_5<Matrix, PType, PreconMethod> st1_5(Mat, P);
//   PreconCreatorStep2<Matrix, PType, PreconMethod> st2(Mat, P);
  
//   {
//     PrintFunctor<PType> pf(P);
//     TimeCalc(comptimepreconditionercreation);
    
//     Execute1(ind, st1, size, rank);
//     //   P.ClearOthers();
//     Execute1(ind, st1_5, size, rank);
//     P.ClearOthers();
//     Execute1(ind, st2, size, rank);

//     //    ForEachInLine(pf, 0);
//     //    if(rank+1==size)
//     //  Execute<ForAllColumnwise>(ind, pf, size, rank);

//   }
//   /*  DoForEachSpecial2 (ind, st1, rank+1 == size);          // special creator
//       DoForEach(ind, st1_5, rank+1==size);
//       P.ClearOthers(rank+1==size);
//       DoForEachSpecial(ind, st2, true);
//   */
  
//   PreconSolverStep1_1_5<Matrix, PType, HdType, GType, PreconMethod> 
//     pcs115(Mat, P, h, G, commtimepreconditioner);
//   PreconSolverStep2<Matrix, PType, HdType, GType, PreconMethod> 
//     pcs2(Mat, P, h, G, commtimepreconditioner);




//   MultiplyMatVector<Matrix, DType, HdType> MulHd(Mat, D, Hd);


  
//   VecDot<GType, HdType> GtG(G, h);
//   VecDot<DType, HdType> DtHd(D, Hd);

  
//   {
//     VecCpy<DType, XType> Cpy(D, X);
//     Execute<ForAll>(ind, Cpy, size, rank);
//   }
  
//   ClearVector(Hd);
//   D.StartSendRecv();
//   ForAllMiddle(ind, MulHd);
//   D.FinishSendRecv();
//   ForAllNonMiddle(ind, MulHd);
  


//   {
//     VecCpy<GType, HdType> Cpy(G, Hd);
//     Execute<ForAll>(ind, Cpy, size, rank);
//     VecSub<GType, RHSType> vsub(G, RHS);
//     Execute<ForAll>(ind, vsub, size, rank);
//   }
//   {
//     // h = C-1g
//     PrintFunctor<PType> pf(Hd);
//     pcs115.Begin();
//     Execute1(ind, pcs115, size, rank);
//     h.ClearOthers();

//     Execute1(ind, pcs2, size, rank);
//     //if(rank==0)
//     //if(rank+1==size)
//     //  Execute<ForAllColumnwiseReverse>(ind, pf, size, rank);
//     //return 0;
//   }
  
//   ClearVector(D); // D = 0;
  
//   {
//     VecSub<DType, HdType> vsub(D, h);
//     Execute<ForAll>(ind, vsub, size, rank);
//     // D = -h;
//   }
  
//   Execute<ForAll>(ind, GtG, size, rank);
//   temp = GtG.GetSum();
//   temp1 = 0;
//   comm.Allreduce(&temp, &temp1, 1, Myf<Double>::Datatype(), MPI::SUM);

//   using namespace std;
//   //cout << rank << " " << temp << " " << temp1 << endl;
//   //return 0;

//   gtgfull = gtg = temp1; // GtG
//   gtgfull *= Eps;
//   unsigned iter = 0;

//   D.StartSendRecv();
//   {
//     TimeCalc(comptimesystemsolveiterations);
//     while (gtg > gtgfull)
//     {
//       if (iter >10100)
// 	break;
//       gtgold = gtg;
//       //		  std::cerr << gtgold << std::endl;

//       // Hd = A.D
//       {
// 	TimeCalc(comptimematvec);
// 	ClearVector(Hd);
// 	ForAllMiddle(ind, MulHd);
//       }
//       {
// 	TimeCalc(commtimematvec);
// 	D.FinishSendRecv();
//       }
//       {
// 	TimeCalc(comptimematvec);
// 	ForAllNonMiddle(ind, MulHd);
//       }
		  
//       // Dt.Hd
//       {
// 	TimeCalc(comptimevecdot);
// 	Execute<ForAll>(ind, DtHd, size, rank); 
//       }
//       {
// 	TimeCalc(commtimevecdot);
// 	temp = DtHd.GetSum();
// 	comm.Allreduce(&temp, &temp1, 1, 
// 		       Myf<Double>::Datatype(), MPI::SUM);
//       }


//       tau = gtg/temp1;

//       {
// 	//		    TimeCalc(comptimevecvec);
// 	//		    VecUpdateClear<GType, HdType> vecu2(G, Hd, tau);
// 	//		    Execute<ForAll>(ind, vecu2, size, rank); // g+= Hd*tau;
//       }

//       {
// 	// Hd = C-1g
// 	VecUpdate<XType, DType> vecu1(X, D, tau);
// 	VecUpdate<GType, HdType> vecu2(G, Hd, tau);

// 	DualFunctorWithMethod2<
// 	  VecUpdate<GType, HdType>,
// 	  PreconSolverStep1_1_5<Matrix, PType, HdType, GType, PreconMethod>
// 	  >
// 	  dualf1(vecu2, pcs115);
		    
// 	DualFunctorWithMethod1<
// 	  PreconSolverStep2<Matrix, PType, HdType, GType, PreconMethod> ,
// 	  VecDot<GType, HdType>
// 	  >
// 	  dualf2(pcs2, GtG);
// 	DualFunctorWithMethod1<
// 	  DualFunctorWithMethod1<
// 	  PreconSolverStep2<Matrix, PType, HdType, GType, PreconMethod> ,
// 	  VecDot<GType, HdType>
// 	  >,
// 	  VecUpdate<XType, DType> 
// 	  >
// 	  trialf(dualf2, vecu1);

// 	TimeCalc(comptimepreconditioner);
		    
// 	dualf1.Begin();
// 	Execute1(ind, dualf1, size, rank);
// 	h.ClearOthers();
// 	Execute1(ind, trialf, size, rank);
//       }
//       /*    pcs1.Begin();
// 	    Hd.ClearOthers(rank+1==size);
// 	    DoForEachSpecial3(ind, pcs1, rank+1==size);
// 	    DoForEach(ind, pcs1_5, rank+1==size);
// 	    DoForEachSpecialReverse(ind, pcs2, rank+1==size);           // Hd = C-1g
//       */
//       {
// 	//			  TimeCalc(comptimevecdot);
// 	//		         Execute<ForAll>(ind, GtG, size, rank); 
//       }
//       {
// 	TimeCalc(commtimevecdot);
// 	temp = GtG.GetSum(); // GtG
// 	comm.Allreduce(&temp, &gtg, 1, 
// 		       Myf<Double>::Datatype(), MPI::SUM);
//       }
//       /*
// 	DoForEach(ind, GtG, rank+1==size);
// 	temp = GtG.GetSum();
// 	comm.Allreduce(&temp, &temp1, 1, Myf<Double>::Datatype(), MPI::SUM);
// 	gtg = temp1;
//       */
//       beta = gtg/gtgold;

//       {
// 	VecUpdate2<DType, HdType> vecu(D, h, beta);
// 	{
// 	  TimeCalc(comptimevecvec);
// 	  //				  ForAllNonMiddle(ind, vecu);
// 	  Execute<ForAll>(ind, vecu, size, rank);
// 	}
// 	{
// 	  TimeCalc(commtimematvec);
// 	  D.StartSendRecv();
// 	}
// 	{
// 	  //				  TimeCalc(comptimevecvec);
// 	  //				  ForAllMiddle(ind, vecu);
// 	}
//       }

//       ++iter;
//     }
//   }
//   D.FinishSendRecv();
//   return iter;     
// }

// template<class Double, class Int>
// template<class PreconMethod>
// unsigned Worker<Double, Int>::PCGm4(
// 				    const matrix_type &Mat,
// 				    bvector_type &X,
// 				    bvector_type &RHS,
// 				    Double Eps,
// 				    Index3dBase<Int> &ind)
// {
//   typedef bvector_type XType;
//   using namespace std;
//   algname += " PCG" + PreconMethod::name();
//   Eps *= Eps;
//   typedef matrix_type Matrix;
//   typedef bvector_type XType;
//   typedef bvector_type RHSType;
//   typedef typename XType::BType DType;
//   typedef typename XType::BType GType;
//   typedef typename XType::BType HdType;  
//   typedef typename XType::BType PType;
  
  
//   PType P(X.N1, X.N2, X.N3, X.N3R);
//   P.CreateDatatypes();
//   P.SetComm(comm);
//   DType D(X.N1, X.N2, X.N3, X.N3R);
//   D.CreateDatatypes();
//   D.SetComm(comm);
//   GType G(X.N1, X.N2, X.N3, X.N3R);
//   G.SetComm(comm);
//   G.CreateDatatypes();
				   
//   HdType Hd(X.N1, X.N2, X.N3, X.N3R);
//   Hd.SetComm(comm);
//   HdType h(X.N1, X.N2, X.N3, X.N3R);
//   h.SetComm(comm);
//   h.CreateDatatypes();
//   Hd.CreateDatatypes();
//   Double gtg, gtgold, tau, beta, gtgfull, temp, temp1;
  

//   PreconCreatorStep1<Matrix, PType, PreconMethod> st1(Mat, P);
//   PreconCreatorStep1_5<Matrix, PType, PreconMethod> st1_5(Mat, P);
//   PreconCreatorStep2<Matrix, PType, PreconMethod> st2(Mat, P);
  
//   {
//     PrintFunctor<PType> pf(P);
//     TimeCalc(comptimepreconditionercreation);
    
//     Execute1(ind, st1, size, rank);
//     //   P.ClearOthers();
//     //Execute<ForAllColumnwise>(ind, pf, size, rank);
//     //    PrintNorm(P, ind);
//     Execute1(ind, st1_5, size, rank);
//     P.ClearOthers();
//     Execute1(ind, st2, size, rank);
//     P.StartSendRecv();
//     P.FinishSendRecv();
    
//     //    ForEachInLine(pf, 0);
//     //    if(rank+1==size)

//   }
//   /*  DoForEachSpecial2 (ind, st1, rank+1 == size);          // special creator
//       DoForEach(ind, st1_5, rank+1==size);
//       P.ClearOthers(rank+1==size);
//       DoForEachSpecial(ind, st2, true);
//   */
  
//   PreconSolverStep1_1_5<Matrix, PType, HdType, GType, PreconMethod> 
//     pcs115(Mat, P, h, G, commtimepreconditioner);
//   PreconSolverStep2<Matrix, PType, HdType, GType, PreconMethod> 
//     pcs2(Mat, P, h, G, commtimepreconditioner);




//   MultiplyMatVector<Matrix, DType, HdType> MulHd(Mat, D, Hd);


  
//   VecDot<GType, HdType> GtG(G, h);
//   VecDot<DType, HdType> DtHd(D, Hd);

  
//   {
//     VecCpy<DType, XType> Cpy(D, X);
//     Execute<ForAll>(ind, Cpy, size, rank);
//   }
  
//   ClearVector(Hd);
//   D.StartSendRecv();
//   ForAllMiddle(ind, MulHd);
//   D.FinishSendRecv();
//   ForAllNonMiddle(ind, MulHd);
  


//   {
//     VecCpy<GType, HdType> Cpy(G, Hd);
//     Execute<ForAll>(ind, Cpy, size, rank);
//     VecSub<GType, RHSType> vsub(G, RHS);
//     //Execute<ForAll>(ind, vsub, size, rank);
//     ForAllNonMiddle(ind, vsub);
//     G.StartSendRecv();
//     ForAllMiddle(ind, vsub);
//     G.FinishSendRecv();
//   }
//   {
//     // h = C-1g
//     PrintFunctor<PType> pf(h);
//     //pcs1.Begin();
//     //Execute1(ind, pcs115, size, rank);
//     //    Execute1(ind, pcs1_5, size, rank);
//     //h.ClearOthers();

//     //Execute1(ind, pcs2, size, rank);
//     //if(rank==0)
//     //if(rank+1==size)
//     //  Execute<ForAllColumnwiseReverse>(ind, pf, size, rank);
//     //return 0;

//     // We now have the lefts so we can procied;
//     pcs115.Begin();
//     Execute1(ind, pcs115, size, rank);

//     h.ClearOthers1();
//     //    return 0;
		    
//     //    h.StartDownLeftPlane();
//     //    Execute<ForAll>(ind, vecu1, size, rank);
//     //    h.FinishDownLeftPlane();
//     //    cout << endl;
//     //ForEachInLine(pf, 2);

//     Execute1(ind, pcs2, size, rank);


//   }
  
//   ClearVector(D); // D = 0;
  
//   {
//     VecSub<DType, HdType> vsub(D, h);
//     Execute<ForAll>(ind, vsub, size, rank);
//     // D = -h;
//   }
  
//   Execute<ForAll>(ind, GtG, size, rank);
//   temp = GtG.GetSum();
//   temp1 = 0;
//   comm.Allreduce(&temp, &temp1, 1, Myf<Double>::Datatype(), MPI::SUM);

//   using namespace std;
//   //  cout << rank << " " << temp << " " << temp1 << endl;
//   //return 0;

//   gtgfull = gtg = temp1; // GtG
//   gtgfull *= Eps;
//   unsigned iter = 0;

//   D.StartSendRecv();
//   {
//     TimeCalc(comptimesystemsolveiterations);
//     while (gtg > gtgfull)
//     {
//       if (iter >8000)
// 	break;
//       gtgold = gtg;
//       //		  std::cerr << gtgold << std::endl;

//       // Hd = A.D
//       {
// 	TimeCalc(comptimematvec);
// 	ClearVector(Hd);
// 	ForAllMiddle(ind, MulHd);
//       }
//       {
// 	TimeCalc(commtimematvec);
// 	D.FinishSendRecv();
//       }
//       {
// 	TimeCalc(comptimematvec);
// 	ForAllNonMiddle(ind, MulHd);
//       }
		  
//       // Dt.Hd
//       {
// 	TimeCalc(comptimevecdot);
// 	Execute<ForAll>(ind, DtHd, size, rank); 
//       }
//       {
// 	TimeCalc(commtimevecdot);
// 	temp = DtHd.GetSum();
// 	comm.Allreduce(&temp, &temp1, 1, 
// 		       Myf<Double>::Datatype(), MPI::SUM);
//       }


//       tau = gtg/temp1;

//       {
// 	//		    TimeCalc(comptimevecvec);
// 	//		    VecUpdateClear<GType, HdType> vecu2(G, Hd, tau);
// 	//		    Execute<ForAll>(ind, vecu2, size, rank); // g+= Hd*tau;
//       }

//       {
// 	// Hd = C-1g
// 	VecUpdate<XType, DType> vecu1(X, D, tau);
// 	VecUpdate<GType, HdType> vecu2(G, Hd, tau);

// 	TimeCalc(comptimepreconditioner);
// 	///G.FinishDownLeftPlane();
// 	ForAllNonMiddle(ind, vecu2);
// 	G.StartSendRecv();
// 	ForAllMiddle(ind, vecu2);
// 	//		    Execute<ForAll>(ind, vecu1, size, rank);
// 	G.FinishSendRecv();

// 	// We now have the lefts so we can proceed;
// 	pcs115.Begin();
// 	Execute1(ind, pcs115, size, rank);
// 	h.ClearOthers1();
		    
// 	//h.StartDownLeftPlane();
// 	//h.FinishDownLeftPlane();
// 	DualFunctorWithMethod1<
// 	  PreconSolverStep2<Matrix, PType, HdType, GType, PreconMethod> ,
// 	  VecUpdate<XType, DType> 
// 	  >
// 	  dualf(pcs2, vecu1);
// 	Execute1(ind, pcs2, size, rank);

// 	Execute<ForAll>(ind, vecu1, size, rank);

//       }
//       /*    pcs1.Begin();
// 	    Hd.ClearOthers(rank+1==size);
// 	    DoForEachSpecial3(ind, pcs1, rank+1==size);
// 	    DoForEach(ind, pcs1_5, rank+1==size);
// 	    DoForEachSpecialReverse(ind, pcs2, rank+1==size);           // Hd = C-1g
//       */
//       {
// 	TimeCalc(comptimevecdot);
// 	Execute<ForAll>(ind, GtG, size, rank); 
//       }
//       {
// 	TimeCalc(commtimevecdot);
// 	temp = GtG.GetSum(); // GtG
// 	comm.Allreduce(&temp, &gtg, 1, 
// 		       Myf<Double>::Datatype(), MPI::SUM);

//       }
//       /*
// 	DoForEach(ind, GtG, rank+1==size);
// 	temp = GtG.GetSum();
// 	comm.Allreduce(&temp, &temp1, 1, Myf<Double>::Datatype(), MPI::SUM);
// 	gtg = temp1;
//       */
//       beta = gtg/gtgold;

//       {
// 	VecUpdate2<DType, HdType> vecu(D, h, beta);
// 	{
// 	  TimeCalc(comptimevecvec);
// 	  //				  ForAllNonMiddle(ind, vecu);
// 	  Execute<ForAll>(ind, vecu, size, rank);
// 	}
// 	{
// 	  TimeCalc(commtimematvec);
// 	  D.StartSendRecv();
// 	}
// 	{
// 	  //				  TimeCalc(comptimevecvec);
// 	  //				  ForAllMiddle(ind, vecu);
// 	}
//       }

//       ++iter;
//     }
//   }
//   D.FinishSendRecv();
//   return iter;     
// }


// template<class Double, class Int>
// Worker<Double, Int>::Worker(MPI::Intracomm  & c,
// 			    Int n1, Int n2, Int n3)
//   :  N1(n1), N2(n2), N3R(n3),comm(c.Dup()), 
// 									 rank(c.Get_rank()), size(c.Get_size())
// {
//   //    if (2*size>n3+1)
//   //        throw runtime_error("Too many processors.");
//   readcoeffs = false;
//   StartLine = rank*(N3R+1)/size;
//   Lines = (rank+1)*(N3R+1)/size - StartLine;
//   mat.SetSize(N1, N2, Lines, N3R);
//   rhs.SetSize(N1, N2, Lines, N3R);
//   x.SetSize(N1, N2, Lines, N3R);
//   //    cout << "Lines " << rank << " " << Lines << endl;
// }


// template<class Double, class Int>
// void Worker<Double, Int>::Reduce(double &a)
// {
//   double tmp = a;
//   comm.Allreduce(&tmp, &a, 1, MPI::DOUBLE, MPI::MAX);
// }

// template<class Double, class Int>
// void Worker<Double, Int>::ClearTimes()
// {
//   commtimevecdot = 0;
//   commtimematvec = 0;
//   commtimepreconditioner = 0;
//   comptime = 0;
//   comptimevecdot = 0;//
//   comptimematvec = 0;//
//   comptimevecvec = 0; // 
//   comptimepreconditioner = 0; //
//   comptimesysgen = 0; // 
//   comptimesystemsolve = 0; //
//   comptimesystemsolveiterations = 0; //
//   comptimepreconditionercreation = 0;
// }

// template<class Double, class Int>
// Double Worker<Double, Int>::CheckSolution()
// {
//   Index3dBase<Int> ind(N1, N2, Lines);
//   SmallVector<Double, 3> h,p,  pl, pd, pf, d,d1;

//   typedef matrix_type Matrix;
//   typedef bvector_type XType;
//   typedef bvector_type RHSType;
//   typedef typename XType::BType DType;
//   typedef typename XType::BType GType;
//   typedef typename XType::BType HdType;

//   HdType Hd(x.N1, x.N2, x.N3, x.N3R);
//   VecSub<HdType, HdType> subber( Hd, rhs);
  
//   ClearVector(Hd);
//   MultiplyMatVector<Matrix, DType, HdType> MulHd(mat, x, Hd);
 

//   //  PrintFunctor<const matrix_type > printmat(Mat);
//   //  Execute<ForAllColumnwise>(ind, printmat, size, rank);
//   //  return 0;

  
//   Execute<ForAll>(ind, MulHd, comm.Get_size(), comm.Get_rank());
//   Execute<ForAll>(ind, subber, comm.Get_size(), comm.Get_rank());
  


//   /*   h[0] = 1./ N1; */
//   /*   h[1] = 1./ N2; */
//   /*   h[2] = 1./ N3R; */
//   Double maxerr = 0;
//   Double maxerr1 = 0;
//   for(int i = 0; i < N1; i++)
//     for(int j = 0; j < N2; j++)
//       for(int k = 0; k < Lines-1; k++)
//       {
// 	ind.SetPos(i, j, k);
// 	/* 	  p[0] = (Double)i *h[0]; */
// 	/* 	  p[1] = (Double)j *h[1]; */
// 	/* 	  p[2] = (Double)(k + StartLine) *h[2]; */
// 	/* 	  pl = p; */
// 	/* 	  pd = p; */
// 	/* 	  pf = p; */
// 	/* 	  pl[1] += h[1]*0.5; */
// 	/* 	  pl[2] += h[2]*0.5; */
	  
// 	/* 	  pf[0] += h[0]*0.5; */
// 	/* 	  pf[2] += h[2]*0.5; */
	  
// 	/* 	  pd[0] += h[0]*0.5; */
// 	/* 	  pd[1] += h[1]*0.5; */
	  
// 	/* 	  d[0] = U(pl) - x[ind][LeftEl]; */
// 	/* 	  d[1] = U(pf) - x[ind][FrontEl]; */
// 	/* 	  d[2] = U(pd) - x[ind][DownEl]; */

// 	d1[0] = Hd[ind][LeftEl];
// 	d1[1] = Hd[ind][FrontEl];
// 	d1[2] = Hd[ind][DownEl];
// 	for(int f = 0; f < 3; ++f)
// 	{
// 	  /* 	      if (fabs(d[f])>maxerr) */
// 	  /* 		maxerr = fabs(d[f]); */
// 	  if (fabs(d1[f])>maxerr1) 
// 	    maxerr = fabs(d1[f]); 
// 	}
// 	//	  cout << setw(15) << d[0] << setw(15) << d[1] << setw(15) << d[2] << endl;
//       }
//   comm.Allreduce(&maxerr, &maxerr1, 1, Myf<Double>::Datatype(), MPI::MAX);
//   return maxerr1;
// }


// template<class Double, class Int>
// void Worker<Double, Int>::PrintSumary()
// {   
//   Reduce(commtimevecdot);
//   Reduce(commtimematvec);
//   Reduce(commtimepreconditioner);
//   Reduce(comptime);
//   Reduce(comptimevecdot);
//   Reduce(comptimematvec);
//   Reduce(comptimevecvec);
//   Reduce(comptimepreconditioner);
//   Reduce(comptimesysgen);
//   Reduce(comptimesystemsolve);
//   Reduce(comptimesystemsolveiterations);
//   Reduce(comptimepreconditionercreation);
//   const int fcs = 30;
//   const int scs = 30;
//   using namespace std;
//   Double err = CheckSolution();

//   if(rank == 0)
//   {
//     cout << setw(fcs) << left << "Problem size "
// 	 << N1 << "x" << N2 << "x" << N3R << " " << Myf<Double>::ToString() << " "
// 	 << algname <<endl;
//     cout << setw(fcs) << left  << "Running on "  
// 	 << setw(scs) <<size  << "procesors." << endl;
//     cout << setw(fcs) << "Iterations" 
// 	 << setw(scs) << iterations << endl;
//     cout << setw(fcs) << "Total time "
// 	 << setw(scs) << comptime << "sec." << endl;
//     cout << setw(fcs) << "Sysgen time" 
// 	 << setw(scs) << comptimesysgen << "sec." << endl;
//     cout << setw(fcs) << "System solve time "
// 	 << setw(scs) << comptimesystemsolve << "sec." <<  endl;
//     cout << setw(fcs) << "Time per iteration " 
// 	 << setw(scs) << comptimesystemsolveiterations
//       /iterations   << "sec." << endl;
//     cout << setw(fcs) << "Time preconditioner"
// 	 << setw(scs) << comptimepreconditioner
//       /iterations << "sec." << endl;
//     cout << setw(fcs) << "Pure time Ax" 
// 	 << setw(scs) << comptimematvec
//       /iterations   << "sec." << endl;
//     cout << setw(fcs) << "Pure time vecdot comp" 
// 	 << setw(scs) << comptimevecdot
//       /iterations/1.<< "sec." << endl;
//     cout << setw(fcs) << "Time vec vec comp" 
// 	 << setw(scs) << comptimevecvec
//       /iterations/1.<< "sec." << endl;
//     //	  cout << endl;
//     cout << setw(fcs) << "Time vecdot comm" 
// 	 << setw(scs) << commtimevecdot
//       /iterations/2. << "sec." << endl;
//     cout << setw(fcs) << "Time Ax comm" 
// 	 << setw(scs) << commtimematvec 
//       /iterations << "sec." << endl;
//     cout << setw(fcs) << "Time precon comm"
// 	 << setw(scs) << commtimepreconditioner
//       /iterations << "sec." << endl;
//     //	  cout << endl;
//     cout << setw(fcs) << "Pure comp time iter"
// 	 << setw(scs) <<(comptimevecdot + comptimevecvec 
// 			 + comptimematvec + comptimepreconditioner-commtimepreconditioner) 
//       /iterations << "sec." <<endl;
//     cout << setw(fcs) << "comm time iter"
// 	 << setw(scs) << (commtimevecdot + commtimematvec
// 			  +commtimepreconditioner)
//       /iterations << "sec." << endl;
//     cout << setw(fcs) << "Time Preconditioner Creation"
// 	 << setw(scs) << comptimepreconditionercreation << "sec." << endl;
//     cout << setw(fcs) << "Error "
// 	 << setw(scs) << err << "sec." << endl;
	  
	  	  
//   }
// }

// template<class Double, class Int>
// void Worker<Double, Int>::Sysgen(DiscretizationType distype, BoundaryConditions bc)

// {
//   switch (distype)
//   {
//   case MV: algname+= "MV";break;
//   case MP: algname+= "MP";break;
//   case RP: algname+= "RP";break;
//   case RV: algname+= "RV";break;
//   }

//   ClearTimes();
//   TimeCalc(comptime);

//   Int NumberOfLines = Lines+1;
//   Int SL = StartLine-1;
//   Int SO = -1;
//   if (rank == 0)
//   {
//     SL++;
//     SO++;
//     NumberOfLines--;
//   }
//   if (rank +1 == size)
//   {
//     NumberOfLines--;
//   }
//   coefficientvec.SetSize(N1, N2, NumberOfLines);
//   std::ostringstream os;
//   os << N3R << ".bone";
//   coefficientvec.SetPars(zero, 0, 1, 0, 1, (double)SL/N3R, (double)(NumberOfLines+SL)/N3R);
//   if(readcoeffs)
//     try{
//       coefficientvec.Read(os.str(), SL);//, NumberOfLines);
//     }catch(std::exception&)
//     {
//       std::cerr << "could not open file" << os.str() << std::endl;
//     }
//   {
//     //	  cout << "Sysgen " << endl;
//     //	  cout << SL << " " << SO << " " << NumberOfLines; 
//     TimeCalc(comptimesysgen);
//     ClearMatrix(mat);
//     ClearVector(rhs);
//     Discretizator<Double> dis(distype);
//     dis.GenerateMatrix(mat, rhs, NumberOfLines, SL, SO, N3R, bc);
//     coefficientvec.Clear();
//     //	  ClearVector(rhs, 1);
//   }
// }



// template<class Double, class Int>
// void Worker<Double, Int>::Solve(Double eps, SolutionMethod method)
// {
//   using namespace std;
//   {
//     TimeCalc(comptime);
//     ClearVector(x);
//     Index3dBase<Int> ind(N1, N2, Lines);
	
//     if (rank == 0)
//       cout << "Starting on " 
// 	   << size << " processors. Eps is "<< eps<< endl;
//     { 
//       TimeCalc(comptimesystemsolve);
//       switch(method)
//       {
//       case smCG:
// 	iterations = CG(mat, x, rhs, eps, ind);
// 	break;
//       case smPCG1:
// 	iterations = PCG<PreconDescriptorM1>(mat, x, rhs, eps, ind);
// 	break;
//       case smPCG2:
// 	iterations = PCG<PreconDescriptorM2>(mat, x, rhs, eps, ind);
// 	break;
//       case smPCG3:
// 	iterations = PCG<PreconDescriptorM3>(mat, x, rhs, eps, ind);
// 	break;
//       case smPCG4:
// 	iterations = PCGm4<PreconDescriptorM4>(mat, x, rhs, eps, ind);
// 	break;
//       }
//     }
//   }
// }


template<class Double, class Int>
NewWorkerScalar<Double, Int>::NewWorkerScalar(MPI::Intracomm  & c,
			    Int n1, Int n2, Int n3)
  :  N1(n1), N2(n2), N3R(n3),comm(c.Dup()), 
     rank(c.Get_rank()), size(c.Get_size())
{
  size = comm.Get_size();
  rank = comm.Get_rank();
  StartLine = rank*(N3R+1)/size;
  Lines = (rank+1)*(N3R+1)/size - StartLine;

  mat.mat.SetSize(N1, N2, Lines, N3R);
  mat.mat.SetComm(comm);
  rhs.SetSize(N1, N2, Lines, N3R);
  rhs.SetComm(comm);
  x.SetSize(N1, N2, Lines, N3R);
  x.SetComm(comm);
  //    cout << "Lines " << rank << " " << Lines << endl;
}

#include "solver.h"
#include "precon.h"
template<class Double, class Int>
Double NewWorkerScalar<Double, Int>::CheckSolution()
{
  Index3dBase<Int> ind(N1, N2, Lines);
  SmallVector<Double, 3> h,p,  pl, pd, pf, d,d1;

  typedef matrix_type Matrix;
  typedef bvector_type XType;
  typedef bvector_type RHSType;
  typedef typename XType::BType DType;
  typedef typename XType::BType GType;
  typedef typename XType::BType HdType;

//   HdType Hd(x.N1, x.N2, x.N3, x.N3R);
//   VecSub<HdType, HdType> subber( Hd, rhs);
  
//   ClearVector(Hd);
//   MultiplyMatVector<Matrix, DType, HdType> MulHd(mat, x, Hd);
 

//   //  PrintFunctor<const matrix_type > printmat(Mat);
//   //  Execute<ForAllColumnwise>(ind, printmat, size, rank);
//   //  return 0;

  
//   Execute<ForAll>(ind, MulHd, comm.Get_size(), comm.Get_rank());
//   Execute<ForAll>(ind, subber, comm.Get_size(), comm.Get_rank());
  


  h[0] = Options::GetOptions().DM1/ N1;
  h[1] = Options::GetOptions().DM2/ N2;
  h[2] = Options::GetOptions().DM3/ N3R;
  Double maxerr = 0;
  Double maxerr1 = 0;
  for(int i = 0; i < N1; i++)
    for(int j = 0; j < N2; j++)
      for(int k = 0; k < Lines-1; k++)
      {
	ind.SetPos(i, j, k);
	p[0] = (Double)i *h[0];
	p[1] = (Double)j *h[1];
	p[2] = (Double)(k + StartLine) *h[2];
	pl = p;
	pd = p;
	pf = p;
	pl[1] += h[1]*0.5;
	pl[2] += h[2]*0.5;
	
	pf[0] += h[0]*0.5;
	pf[2] += h[2]*0.5;
	  
	pd[0] += h[0]*0.5;
	pd[1] += h[1]*0.5;
	  
	d[0] = U(pl) - x[ind][LeftEl];
	d[1] = U(pf) - x[ind][FrontEl];
	d[2] = U(pd) - x[ind][DownEl];
	
	for(int f = 0; f < 3; ++f)
	{
	  /* 	      if (fabs(d[f])>maxerr) */
	  /* 		maxerr = fabs(d[f]); */
	  if (fabs(d[f])>maxerr) 
	    maxerr = fabs(d[f]); 
	}
	
	//	cout << setw(15) << d[0] << setw(15) << d[1] << setw(15) << d[2] << endl;
      }
  comm.Allreduce(&maxerr, &maxerr1, 1, Myf<Double>::Datatype(), MPI::MAX);
  return maxerr1;
}

template<class Double, class Int>
int
NewWorkerScalar<Double, Int>::
Solve(Double eps, SolutionMethod method)
{
  const int fcs=30;
  const int scs=30;
  PCGSolverBase<bvector_type>
    solver;
  solver.SetMatrix(&mat);
  solver.SetEps(eps);
  solver.SetSizes(N1, N2, Lines, N3R);
  solver.SetComm(comm);
  ClearVector(x);
  PreconBase<bvector_type> *precon = NULL;
  switch(method)
  {
  case smCG:
    precon = new NoPrecon<bvector_type>();
    break;
  case smPCG1:
    {
      MIC0Precon<matrix_type, bvector_type, bvector_type,  PreconDescriptorM1> *p
	= new MIC0Precon<matrix_type, bvector_type, bvector_type, PreconDescriptorM1>;
      p->Create(mat.mat);
      precon = p;
    }    
    break;
  case smPCG2:
    {
      MIC0Precon<matrix_type, bvector_type, bvector_type, PreconDescriptorM2> *p
	= new MIC0Precon<matrix_type, bvector_type, bvector_type, PreconDescriptorM2>;
      p->Create(mat.mat);
      precon = p;
    }    
  
    break;
  case smPCG3:
      {
      MIC0Precon<matrix_type, bvector_type, bvector_type,  PreconDescriptorM3> *p
	= new MIC0Precon<matrix_type, bvector_type, bvector_type,  PreconDescriptorM3>;
      p->Create(mat.mat);
      precon = p;
    }    

    break;
  case smPCG4:
    {
      MIC0PreconM4<matrix_type, bvector_type, bvector_type, PreconDescriptorM4> *p
	= new MIC0PreconM4<matrix_type, bvector_type, bvector_type,  PreconDescriptorM4>;
      p->Create(mat.mat);
      precon = p;
    }    
    break;
  default:;
  }
  solver.SetPrecon(precon);



  if (rank == 0)
  {
    cout << "Starting  on " 
	 << size << " processors. Eps is "<< eps<< endl;
    
    cout << setw(fcs) << left << "Problem size "
	 << N1 << "x" << N2 << "x" << N3R << " " << Myf<Double>::ToString() << " "
	 << algname + solver.GetName() <<endl;
    cout << setw(fcs) << left  << "Running on "  
	 << setw(scs) <<size  << "procesors." << endl;
  }
  int iterations  = solver.Solve(x, rhs);
  if (rank == 0)
  {
    cout << setw(fcs) << "Iterations" 
	 << setw(scs) << iterations << endl;
  }
  delete precon;
  return iterations;
}


template<class Double, class Int>
void
NewWorkerScalar<Double, Int>::
Sysgen(DiscretizationType distype, BoundaryConditions bc)
{
  switch (distype)
  {
  case MV: algname+= "MV";break;
  case MP: algname+= "MP";break;
  case RP: algname+= "RP";break;
  case RV: algname+= "RV";break;
  }
  algname += " ";
  if(bc & bcLeft)
    algname += "l";
  if(bc & bcRight)
    algname += "r";
  if(bc & bcDown)
    algname += "d";
  if(bc & bcUp)
    algname += "u";
  if(bc & bcFront)
    algname += "f";
  if(bc & bcBack)
    algname += "b";
  algname += " ";

  Int NumberOfLines = Lines+1;
  Int SL = StartLine-1;
  Int SO = -1;
  if (rank == 0)
  {
    SL++;
    SO++;
    NumberOfLines--;
  }
  if (rank +1 == size)
  {
    NumberOfLines--;
  }
  coefficientvec.SetSize(N1, N2, NumberOfLines);
  std::ostringstream os;
  os << N3R << ".bone";
  coefficientvec.SetPars(Options::GetOptions().zero, 0, 1, 0, 1, (double)SL/N3R, (double)(NumberOfLines+SL)/N3R);
  for(int i = 0; i < N1; ++i)
    for(int j = 0; j < N2; ++j)
      for(int k = 0; k < NumberOfLines; ++k)
	coefficientvec(i,j,k) = 1.;
  if(Options::GetOptions().usebone)
    try{
      coefficientvec.Read(os.str(), SL);//, NumberOfLines);
    }catch(std::exception&)
    {
      std::cerr << "could not open file" << os.str() << std::endl;
    }
  {
    ClearMatrix(mat.mat);
    ClearVector(rhs);
    Discretizator<Double> dis(distype);
    dis.GenerateMatrix(mat.mat, rhs, NumberOfLines, SL, SO, N3R, bc);
    coefficientvec.Clear();
    //	  ClearVector(rhs, 1);
  }
}



#endif

