#include "vectors.hpp"


#ifndef USE_EXPORT
#include "small.h"
// some explicit specializations
//double
template class BDom<double, int>;
template class BDom<SmallVector<double, 6>, int>;
template class BDom<SmallVector<double, 3>, int>;

template
void ClearMatrix(BDom<SmallVector<double, 6>, int > & mat);

template
void ClearVector(BDom<double, int> & vec, int AAA );

template
void ClearVector(BDom<SmallVector<double, 3> , int> & vec, int AAA );


//float
#ifdef _FLOAT_EXPAND
template class BDom<float, int>;
template class BDom<SmallVector<float, 6>, int>;
template class BDom<SmallVector<float, 3>, int>;

template
void ClearMatrix(BDom<SmallVector<float, 6>, int > & mat);

template
void ClearVector(BDom<float, int> & vec, int AAA );


template
void ClearVector(BDom<SmallVector<float, 3> , int> & vec, int AAA );

#endif //float
#endif //export
