#include "poly.h"
#include "calc.h"
#include <iostream>
#include <complex>
#include <cmath>
#include "small.h"
#include "smallops.h"

template<class T>
int Permute(std::vector<T> &mas, int max)
{
  for (int i = 0; i < mas.size(); ++i)
  {
    mas[i]++;
    if (mas[i] < max)
      return true;
    mas[i] = 0;
  }
  return false;
}

int main()
{
  typedef double T;
  SmallMatrix<T, 3, 3> a;
  SmallMatrix<T, 3, 3> v;
  SmallVector<T, 3> llambda;
  a[0][0] = 7.9222931442033367e+09; a[0][1] =-4.1330851217609067e+06;  a[0][2] = 9.1885319096977403e+05;
  a[1][0] =-4.1330851217609067e+06; a[1][1] = 7.9151502324158363e+09;  a[1][2] = 1.0309712002660587e+06;
  a[2][0] = 9.1885319096977403e+05; a[2][1] = 1.0309712002660587e+06;  a[2][2] = 7.8749144658793335e+09;
  My::Calc::REigenStuff(a, llambda, v);
  std::cout << "l - "<< llambda << std::endl;

}

