#include <iostream>
#include <iomanip>
int main()
{
  double E_f = 1e9;
  double E_m = 1e9;
  double nu_f = 0.3;
  double nu_m = 0.3;
  double C = 0.9;//0.5;//66666666;
  double V_f = 0.5;
  double V_m = 0.5;

  double v[2] = {0.5, 0.25};
  double zeta[] = {1e-2, 1e-1, 1e1, 1e2}; 


  for (int i = 0; i < 2; ++i)
  {
    V_f = v[i];
    V_m = 1.-V_f;
    for (int k = 0; k < sizeof(zeta)/sizeof(double); ++k)
    {
      E_f=E_m*zeta[k];
      double K_f = E_f/(2.*(1-nu_f));
      double G_f = E_f/(2.*(1+nu_f));
      double K_m = E_m/(2.*(1-nu_m));
      double G_m = E_m/(2.*(1+nu_m));
      
      double &nu_d = nu_f;
      double &E_d = E_f;
      double &V_d = V_f;
      double E_2 = 2*(1-nu_f + (nu_f - nu_m)*V_m)*
	(
	 (1-C)*(K_f*(2*K_m + G_m) - G_m*(K_f - K_m)*V_m)/
	 (     (2*K_m + G_m) + 2*(K_f - K_m)*V_m) +
	 C * (K_f*(2.*K_m+G_f) + G_f *(K_m - K_f)*V_m)/
	 (    (2.*K_m + G_f) - 2.*(K_m - K_f)*V_m));
      
      
      double nu = ((1-nu_m - 2 * nu_m * nu_m)*nu_d*E_d*V_d +
		   (1-nu_d - 2*nu_d*nu_d)*nu_m * E_m * V_m)/
	((1-nu_m - 2 * nu_m * nu_m)*E_d*V_d +
	 (1-nu_d - 2*nu_d*nu_d)* E_m * V_m);
      std::cout << "E_F V_f  = " << E_f << " "<< V_f << std::endl;
      //    std::cout << "nu_f = " << nu_f << std::endl;
      //    std::cout << "E_m  = " << E_m << std::endl;
      //std::cout << "nu_m = " << nu_m << std::endl;
      //    std::cout << "E_2  = " << E_2 << std::endl;
      
      // double E = (1 - nu_d - 4*nu_d * nu + 2* nu*nu)*E_d *V_d/
      //   (1 - nu_d - 2*nu_d*nu_d) +
      //   (1-nu_m - 4*nu_m * nu + 2* nu*nu)*E_m*V_m/
      //   (1 - nu_m - 2*nu_m*nu_m);
      // std::cout << "nu   = " << nu << std::endl;
      // std::cout << "E    = " << E << std::endl;
      double E_min = E_m*E_f/(V_m*E_f + V_f *E_m);
      double E_max = E_m*V_m + E_f *V_f;
      
      std::cout << "Emax Emi Tsoj "
		<< std::setw(15) << E_max 
		<< std::setw(15) << E_min
		<< std::setw(15) << E_2
		<<std::endl << std::endl;
      
    }
  }
  
}
