#include <iostream>
#include <fstream>
#include <string>
#include <sstream>

#include "mirorer.h"


int main(int argc, char **argv)
{
  if (argc != 2)
    return -1;
  using namespace std;
  string fname = argv[1];
  int N;
  {
    istringstream is(argv[1]);
    is >> N;
  }
  ifstream f(fname.c_str());

  vector3d<double> vec;
  vector3d<double>vec1;
  vector3d<double>A;
  vec.SetSize(N, N, N);
  vec1.SetSize(N, N, N);
  A.SetSize(3, 3, 3);
  for(int i = 0; i <3; ++i)
    for(int j = 0; j < 3; ++j)
      for(int k = 0; k < 3; ++k)
	A(i,j,k) = 1./27.;
  
  vec.Read(fname, 0);
  for(int k = 0; k < N/2; ++k)
    for(int i = 0; i < N/2; ++i)
      for(int j = 0; j < N/2; ++j)
	vec1(i,j,k) = vec(i,j,k);
  for(int k = 1; k < N-1; ++k)
    for(int i = 1; i < N-1; ++i)
      for(int j = 1; j < N-1; ++j)
	vec1(i,j,k) = 0;
  for(int k = 0; k < N; ++k)
    for(int i = 0; i < N; ++i)
      for(int j = 0; j < N; ++j)
	vec1(i,j,k)=0;
  for(int k = 1; k < N-1; ++k)
    for(int i = 1; i < N-1; ++i)
      for(int j = 1; j < N-1; ++j)
	for(int I = -1; I <= 1; ++I)
	  for(int J = -1; J <= 1; ++J)
	    for(int K = -1; K <= 1; ++K)
	      vec1(i,j,k) += vec(I+i, J+j, K+k)*A(I+1, J+1, K+1);

  ostringstream fn;
  fn << fname << ".bl";
  vec1.Write(fn.str());
  return 0;
}
	  
    
  
