#include <iostream>
#include <fstream>
#include <string>
#include <sstream>

#include "mirorer.h"


int main(int argc, char **argv)
{
  if (argc != 2)
    return -1;
  using namespace std;
  string fname = argv[1];
  int N;
  {
    istringstream is(argv[1]);
    is >> N;
  }

  vector3d<double> vec;
  vector3d<double>vec1;
  vec.SetSize(N, N, N);
  vec.Read(fname, 0);
  vec1.SetSize(N>>1, N>>1, N>>1);
  for(int k = 0; k < N/2; ++k)
    for(int i = 0; i < N/2; ++i)
      for(int j = 0; j < N/2; ++j)
	vec1(i,j,k) = 0;
  
  for(int k = 0; k < N; ++k)
    for(int i = 0; i < N; ++i)
      for(int j = 0; j < N; ++j)
	vec1(i>>1, j >>1, k>>1) += vec(i,j,k)/8.;

  ostringstream fn;
  fn << N/2 << "." << fname;
  vec1.Write(fn.str());
  return 0;
}
	  
    
  
