#include <iostream>
#include <fstream>
#include <string>
#include <sstream>

#include "mirorer.h"


int main(int argc, char **argv)
{
  if (argc < 3)
    return -1;
  using namespace std;
  string fname = argv[1];
  int field;
  int maxfield=15;
  int N;
  if(argc==4)
  {
    istringstream is(argv[3]);
    is >> maxfield;
    if(maxfield!=21)
      maxfield=15;
  }
  {
    istringstream is(argv[2]);
    is >> field;
  }
  {
    istringstream is(argv[1]);
    is >> N;
  }
  ifstream f(fname.c_str());

  vector3d<double> vec;
  vec.SetSize(N, N, N);
  double val;
  int i, j, k;
  f.exceptions(ios::eofbit);
  try{
  for( k = 0; k < N; ++k)
    for( i = 0; i < N; ++i)
      for( j = 0; j < N; ++j)
	for(int l = 0; l < maxfield; ++l)
	{
	  double d;
	  f >> d;
	  if (field==l)
	    vec(i,j,k)=val = d;
	}
  }catch(...)
  {
    cout << "File not long enough" << endl;
    for(; k < N; ++k)
    {
      for(; i < N; ++i)
      {
	for(; j < N; ++j)
	  vec(i,j,k)=val;
	j = 0;
      }
      i = 0;
    }
  }
  ostringstream fn;
  fn << N << ".f." << field;
  vec.Write(fn.str());
  return 0;
}
	  
    
  
