#include <iostream>
#include <string>
#include <sstream>
#include "mirorer.h"


int main(int argc, char **argv)
{
  std::string filename = "default";
  if (argc >1)
    filename = argv[1];
  std::string pars = "";
  if (argc >2)
    pars = argv[2];
  std::istringstream is(filename);
  int sz;
  is >> sz;
  std::istringstream is1(pars);
  int par;
  is1 >> par;
  std::cout << "size is " << sz  << " extracting " << par<< std::endl;
  vector3d<unsigned char > vec;
  vector3d<unsigned char > vec1;

  std::ostringstream os;
  int div = 4;
  os << sz/div <<"." << par <<".bonec";
  
  vec.SetSize(sz,sz,sz);
  vec1.SetSize(sz/div,sz/div,sz/div);
  vec.Read(filename, 0);
  for (int i = 0; i < sz/div; ++i)
    for (int j = 0; j < sz/div; ++j)
      for (int k = 0; k < sz/div; ++k)
	vec1(i,j,k) = 0;
  
  for (int i = 0; i < sz; ++i)
    for (int j = 0; j < sz; ++j)
      for (int k = 0; k < sz; ++k)
	if (vec(i,j,k)==par)
	{
	  vec1(i/div,j/div,k/div) = 255;
	}
  vec1.Write(os.str());
  //  std::cout << "written " << (double)nzcount/sz1/sz2/sz3 << std::endl;
}
