#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <cmath>

#include "mirorer.h"


int main(int argc, char **argv)
{
  if (argc != 2)
    return -1;
  using namespace std;
  string fname = argv[1];
  int N;
  {
    istringstream is(argv[1]);
    is >> N;
  }
  ifstream f(fname.c_str());

  vector3d<unsigned char> vec;
  vec.SetSize(N, N, N);
  for(int i = 0; i <N; ++i)
    for(int j = 0; j <N; ++j)
      for(int k = 0; k < N; ++k)
      {
	bool write = false;
	bool n1, n2, n3;
	n1 = ((i+0)%16)==8;
	n2 = ((j+0)%8)==4;
	n3 = ((k+0)%4)==2;
	write = n1 || n2 || n3;
	vec(i,j,k)=(write)?255:0;
	  
      }
//       {
// 	int r2 = N*N/4;
// 	int R = 2;
// 	r1 = sqrt(r1);
// 	r2 = sqrt(r2);
// 	write |= abs(r1-r2)<=R;
// 	r1 = (i-N/2)*(i-N/2) + (j-N/2)*(j-N/2) + (N-k)*(N-k);
// 	r2 = N*N/4;
// 	r1 = sqrt(r1);
// 	r2 = sqrt(r2);
// 	write |= abs(r1-r2)<=R;
// 	R = N/8;
// 	bool b2 = (i>R) && (i<N-R) &&(j>R) && (j<N-R);
// 	write &=b2;
// 	vec(i,j,k)=(write)?255:0;
	  
//       }
  ostringstream fn;
  fn << N << "." << "arc";
  vec.ConvertAllTo(1);
  //  vec.RemoveBad(20);
  vec.ConvertAllTo(255);  
 
  vec.Write(fn.str());
  return 0;
}
	  
    
  
