#include <iostream>


void output(int start, int count, double emin, double nimin, double emax, double nimax)
{
  for(int i = 0; i < count; ++i)
  {
    std:: cout << i+start << " "
	       << ( nimin*(double(count-1 - i)/(count-1)) + nimax*(double(i)/(count-1)) ) << " "
	       << ( emin*(double(count-1 - i)/(count-1)) + emax*(double(i)/(count-1)) ) << "\n";
  }
}

void outputone(int one, double e, double ni)
{
  std::cout << one << " " << ni << " " << e << "\n";
}

int main()
{
  double MPA = 1e6;
  outputone(0, 0.001*MPA, 0.1);
  output(1, 64, 200*MPA, 0.1, 500*MPA,  0.175);
  output(65, 64, 500*MPA,  0.175, 2100*MPA, 0.25);
  output(129, 127, 4000*MPA,  0.25, 4000*MPA, 0.25);
}
