#include <iostream>
#include <string>
#include <sstream>
#include "mirorer.h"


int main(int argc, char **argv)
{
  std::string filename = "default";
  if (argc >1)
    filename = argv[1];
  std::istringstream is(filename);
  int sz;
  is >> sz;
  std::string fame = "132";
  if (argc >2)
    fame = argv[2];
  std::istringstream is1(fame);
  int tres;
  is1 >> tres;
  
  std::cout << "size is " << sz << std::endl;
  std::cout << "tres is " << tres << std::endl;
  vector3d<unsigned char > vec;
  vector3d<unsigned short > wvec;
  vec.ReadInr(filename);
  wvec.SetSize(vec);
  std::cout << "read" << std::endl;
  int sz1, sz2, sz3;
  sz1 = vec.sizes[0];
  sz2 = vec.sizes[1];
  sz3 =vec.sizes[2];
  unsigned char ch;
  for(int i = 0; i < sz1; ++i)
    for(int j = 0; j < sz2; ++j)
      for(int k = 0; k < sz3; ++k)
	wvec(i,j,k)=((ch=vec(i,j,k))>tres)?ch:0;
  filename +="c";
  wvec.ConvertAllTo(1);
  wvec.RemoveBad(200);
  wvec.ConvertAllTo(1);
  std::cout << "Converting..." << std::endl;
  int nzcount = 0;
  for(int i = 0; i < sz1; ++i)
    for(int j = 0; j < sz2; ++j)
      for(int k = 0; k < sz3; ++k)
      {
	nzcount+=wvec(i,j,k);
	vec(i,j,k)*=wvec(i,j,k);
      }
  vec.ConvertAllTo(255);
  vec.WriteInr("c"+filename);
  std::cout << "written " << (double)nzcount/sz1/sz2/sz3 << std::endl;
}
