#include <iostream>
#include <fstream>
#include <string>
#include <sstream>

#include "mirorer.h"


int main(int argc, char **argv)
{
  if (argc != 2)
    return -1;
  using namespace std;
  string fname = argv[1];
  std::fstream is(argv[1]);

  int n = 10;
  vector3d<unsigned char> vec;
  vec.SetSize(512, 512, n, 1, 1, 1);

  for(int i = 0; i < vec.sizes[0]; ++i)
    for(int j = 0; j < vec.sizes[1]; ++j)
      for(int k = 0; k < vec.sizes[2]; ++k)
	vec(i,j,k) = 3;
  
  const double thres = 20;
  for(int i = 0; i < vec.sizes[0]; ++i)
    for(int j = 0; j < vec.sizes[1]; ++j)
    {
      double a;
      is >> a;
      unsigned char val = (a>thres)?255:1;
      for(int k = 2; k < vec.sizes[2]-2; ++k)
	vec(i, j, k) = val;
    }
  
  ostringstream fn;
  fn << "t" << fname << ".inr" ;
  vec.WriteInr(fn.str());
  return 0;
}
	  
    
  
