#ifndef __mmpl_h__
#define __mmpl_h__
#include "ttl/meta/typelist.hpp"
#include "basic.h"
#include "visitors.h"


template<int a>
struct int_{enum{value=a};};


template<Elment where>
struct VecAccesor1
{
 template<class Vec, class Index>
static
 typename Vec::base_type&
  doit(Vec &vec, const Index &ind)
  {
    return vec.Index(ind)[where];
  }
};

#define _DECL_(Name)                            \
template<class Int>                             \
struct S_ ## Name{                              \
  static Int Calc(Index3dBase<Int> const &i)    \
  {                                             \
    return i.B##Name();                         \
  }                                             \
}                                              

_DECL_(Up);
_DECL_(Down);
_DECL_(Left);
_DECL_(Right);
_DECL_(Front);
_DECL_(Back);
_DECL_(RightFront);
_DECL_(BackDown);
_DECL_(RightDown);
_DECL_(This);




template<Elment where, template<class > class what>
struct VecAccesor
{
  static const Elment El = where;
  template<class Vec, class Int>
  static
  typename Vec::base_type &
  Do(Vec &vec, const Index3dBase<Int> &ind)
  {
    return VecAccesor1<where>::doit(vec, what<Int>::Calc(ind));
  }
};

struct PreconDescriptorBase
{
public:
  template<Elment El>
  struct Lists;

			
};

  template<>
  struct PreconDescriptorBase::Lists<LeftEl>
  {

    typedef ttl::meta::typelist<
      VecAccesor<LeftEl,  S_This>,
      VecAccesor<FrontEl, S_This>,
      VecAccesor<DownEl,  S_This>,
      VecAccesor<DownEl,  S_Up>,
      VecAccesor<FrontEl, S_Back>,
      VecAccesor<LeftEl,  S_Right>
    > Func;
  };
  template<>
  struct PreconDescriptorBase::Lists<FrontEl>
  {
    typedef ttl::meta::typelist<
      VecAccesor<FrontEl, S_This>,
      VecAccesor<DownEl,  S_This>,
      VecAccesor<DownEl,  S_Up>,
      VecAccesor<FrontEl, S_Back>,
      VecAccesor<LeftEl,  S_RightFront>,
      VecAccesor<LeftEl,  S_Right>
    > Func;
  };
  template<>
  struct PreconDescriptorBase::Lists<DownEl>
  {
    typedef ttl::meta::typelist<
      VecAccesor<DownEl,  S_This>,
      VecAccesor<DownEl,  S_Up>,
      VecAccesor<FrontEl, S_BackDown>,
      VecAccesor<FrontEl, S_Back>,
      VecAccesor<LeftEl,  S_RightDown>,
      VecAccesor<LeftEl,  S_Right>
    > Func;    
  };		

class PreconDescriptorM1
{
 public:
  template<class In, class Functor, class FunctorDown, class FunctorUp>
  class Creator1:public ForAll<In, Functor, FunctorDown, FunctorUp>
  {
  public:
  };
  template<class In, class Functor, class FunctorDown, class FunctorUp>
  class Creator1_5:public ForAll<In, Functor, FunctorDown, FunctorUp>
  {
  public:
  };
  template<class In, class Functor, class FunctorDown, class FunctorUp>
  class Creator2:public ForAll<In, Functor, FunctorDown, FunctorUp>
  {
  public:
  };
  template<class In, class Functor, class FunctorDown, class FunctorUp>
  class Solver1:public ForAll<In, Functor, FunctorDown, FunctorUp>
  {
  public:
  };
  template<class In, class Functor, class FunctorDown, class FunctorUp>
  class Solver1_5:public ForAll<In, Functor, FunctorDown, FunctorUp>
  {
  public:
  };
  template<class In, class Functor, class FunctorDown, class FunctorUp>
  class Solver2:public ForAllReverse<In, Functor, FunctorDown, FunctorUp>
  {
  public:
  };
  
 public:
  static const std::string name()
    {
      return "M1";
    }

  template<Elment El>
  struct Lists:public PreconDescriptorBase::template Lists<El>
  {
    typedef ttl::meta::typelist<
      int_<1>,
      int_<2>,
      int_<3>,
      int_<4>,
      int_<5>
    > IntrestedIn;
    typedef ttl::meta::typelist<
      > NotIntrestedIn;
  };  
};


class PreconDescriptorM2
{
 public:
  template<class In, class Functor, class FunctorDown, class FunctorUp>
  class Creator1:public ForAllMore<In, Functor, FunctorDown, FunctorUp>
  {
  public:
  };
  template<class In, class Functor, class FunctorDown, class FunctorUp>
  class Creator1_5:public ForAll<In, Functor, FunctorDown, FunctorUp>
  {
  public:
  };
  template<class In, class Functor, class FunctorDown, class FunctorUp>
  class Creator2:public ForAllColumnwiseM2Up<In, Functor, FunctorDown, FunctorUp>
  {
  public:
  };
  template<class In, class Functor, class FunctorDown, class FunctorUp>
  class Solver1:public ForAllColumnwiseM2Up<In, Functor, FunctorDown, FunctorUp>
  {
  public:
  };
  template<class In, class Functor, class FunctorDown, class FunctorUp>
  class Solver1_5:public ForAll<In, Functor, FunctorDown, FunctorUp>
  {
  public:
  };
  template<class In, class Functor, class FunctorDown, class FunctorUp>
  class Solver2:public ForAllColumnwiseM2Down<In, Functor, FunctorDown, FunctorUp>
  {
  public:
  };




  static const std::string name()
    {
      return "M4";
    }

  template<Elment El>
  struct Lists;
  

};
  template<>
  struct PreconDescriptorM2::Lists<LeftEl>:public PreconDescriptorBase:: Lists<LeftEl>
  {
    typedef ttl::meta::typelist<
      int_<1>,
      int_<2>,
      int_<3>,
      int_<4>
    > IntrestedIn;
    typedef ttl::meta::typelist<
      int_<5>
      > NotIntrestedIn;
  };  
  template<>
  struct PreconDescriptorM2::Lists<FrontEl>:public PreconDescriptorBase::Lists<FrontEl>
  {
    typedef ttl::meta::typelist<
      int_<1>,
      int_<2>,
      int_<4>,
      int_<5>
    > IntrestedIn;
    typedef ttl::meta::typelist<
      int_<3>
      > NotIntrestedIn;
  };  
  template<>
  struct PreconDescriptorM2::Lists<DownEl>:public PreconDescriptorBase::Lists<DownEl>
  {
    typedef ttl::meta::typelist<
      int_<2>,
      int_<3>,
      int_<4>,
      int_<5>
    > IntrestedIn;
    typedef ttl::meta::typelist<
      int_<1>
      > NotIntrestedIn;
  };  

class PreconDescriptorM4:public PreconDescriptorM2
{
 public:
  template<class In, class Functor, class FunctorDown, class FunctorUp>
  class Creator1:public ForAllMore<In, Functor, FunctorDown, FunctorUp>
  {
  public:
  };
  template<class In, class Functor, class FunctorDown, class FunctorUp>
  class Creator1_5:public ForAll<In, Functor, FunctorDown, FunctorUp>
  {
  public:
  };
  template<class In, class Functor, class FunctorDown, class FunctorUp>
  class Creator2:public ForAllColumnwiseM2Up<In, Functor, FunctorDown, FunctorUp>
  {
  public:
  };
  template<class In, class Functor, class FunctorDown, class FunctorUp>
  class Solver1:public ForAllColumnwiseM4Up<In, Functor, FunctorDown, FunctorUp>
  {
  public:
  };
  template<class In, class Functor, class FunctorDown, class FunctorUp>
  class Solver1_5:public ForAll<In, Functor, FunctorDown, FunctorUp>
  {
  public:
  };
  template<class In, class Functor, class FunctorDown, class FunctorUp>
  class Solver2:public ForAllColumnwiseM4Down<In, Functor, FunctorDown, FunctorUp>
  {
  public:
  };

  static const std::string name()
    {
      return "M4";
    }
};

class PreconDescriptorM3
{
 public:
  template<class In, class Functor, class FunctorDown, class FunctorUp>
  class Creator1:public ForAllMore<In, Functor, FunctorDown, FunctorUp>
  {
  public:
  };
  template<class In, class Functor, class FunctorDown, class FunctorUp>
  class Creator1_5:public ForAll<In, Functor, FunctorDown, FunctorUp>
  {
  public:
  };
  template<class In, class Functor, class FunctorDown, class FunctorUp>
  class Creator2:public ForAllM3Up<In, Functor, FunctorDown, FunctorUp>
  {
  public:
  };
  template<class In, class Functor, class FunctorDown, class FunctorUp>
  class Solver1:public ForAllM3Up<In, Functor, FunctorDown, FunctorUp>
  {
  public:
  };
  template<class In, class Functor, class FunctorDown, class FunctorUp>
  class Solver1_5:public ForAll<In, Functor, FunctorDown, FunctorUp>
  {
  public:
  };
  template<class In, class Functor, class FunctorDown, class FunctorUp>
  class Solver2:public ForAllM3Down<In, Functor, FunctorDown, FunctorUp>
  {
  public:
  };

  static const std::string name()
    {
      return  "M3";
    }

  template<Elment El>
  struct Lists:public PreconDescriptorBase::template Lists<El>
  {
    typedef ttl::meta::typelist<
      int_<4>,
      int_<5>
    > IntrestedIn;
    typedef ttl::meta::typelist<
      int_<1>,
      int_<2>,
      int_<3>
      > NotIntrestedIn;
  };
};

  template<>
  struct PreconDescriptorM3::Lists<LeftEl>:public PreconDescriptorBase::Lists<LeftEl>
  {
    typedef ttl::meta::typelist<
      int_<1>,
      int_<2>,
      int_<3>,
      int_<4>
    > IntrestedIn;
    typedef ttl::meta::typelist<
      int_<5>
      > NotIntrestedIn;
  };


#endif
