#include <iostream>
#include <fstream>
#include <vector>

template<class T, class V>
T Read(const V&s)
{
  std::string v(s);
  std::istringstream f(v);
  T a;
  f >>a;
  return a;
}


int main(int argc, char **argv)
{
  if (argc!=3)
    return 1;

  std::ifstream f(argv[1]);
  int N ;
  f >> N;
  std::ifstream g(argv[2]);

  std::vector<std::string> vec(N);
  std::vector<int> ind(N, 0);
  for (int i = 0; i < N; ++i)
  {
    int a, b;
    f >> a >> b;
    getline(g, vec[i]);
    ind[i] = b;
  }
  for (int i = 0; i < N; ++i)
  {
    std::cout << vec[ind[i]] << std::endl;
  }
}
