#ifndef __visitors_h__
#define __visitors_h__
#include "basic.h"
#include "index.h"
#include "vectors.h"
EXPORT
template<class Int, class Functor, class FunctorDown, class FunctorUp>
class ForAll{
 public:
void operator()(Index3dBase<Int> const &ind, 
		Functor &F, FunctorDown &FDown, FunctorUp &FUp);
};
EXPORT
template<class Int, class Functor, class FunctorDown, class FunctorUp>
class ForAllPBC{
 public:
void operator()(Index3dBase<Int> const &ind, 
		Functor &F, FunctorDown &FDown, FunctorUp &FUp);
};
EXPORT
template<class Int, class Functor, class FunctorDown, class FunctorUp>
class ForAllPBC1{
 public:
void operator()(Index3dBase<Int> const &ind, 
		Functor &F, FunctorDown &FDown, FunctorUp &FUp);
};
EXPORT
template<class Int, class Functor, class FunctorDown, class FunctorUp>
class ForAllReduce{
 public:
void operator()(Index3dBase<Int> const &ind, 
		Functor &F, FunctorDown &FDown, FunctorUp &FUp);
};
EXPORT
template<class Int, class Functor, class FunctorDown, class FunctorUp>
class ForAllReverse{
 public:
void operator()(Index3dBase<Int> const &ind, 
		Functor &F, FunctorDown &FDown, FunctorUp &FUp);
};

EXPORT
template<class Int, class Functor, class FunctorDown, class FunctorUp>
class ForAllWithoutDown{
 public:
void operator()(Index3dBase<Int> const &ind, 
		Functor &F, FunctorDown &FDown, FunctorUp &FUp);
};
EXPORT
template<class Int, class Functor, class FunctorDown, class FunctorUp>
class ForDownOnly{
 public:
void operator()(Index3dBase<Int> const &ind, 
		Functor &F, FunctorDown &FDown, FunctorUp &FUp);
};

EXPORT
template<class Int, class Functor, class FunctorDown, class FunctorUp>
class ForAllM3Up{
 public:
void operator()(Index3dBase<Int> const &ind, 
		Functor &F, FunctorDown &FDown, FunctorUp &FUp);
};
EXPORT
template<class Int, class Functor, class FunctorDown, class FunctorUp>
class ForAllM3Down{
 public:
void operator()(Index3dBase<Int> const &ind, 
		Functor &F, FunctorDown &FDown, FunctorUp &FUp);
};

EXPORT
template<class Int, class Functor, class FunctorDown, class FunctorUp>
class ForAllPBCM3Up{
 public:
void operator()(Index3dBase<Int> const &ind, 
		Functor &F, FunctorDown &FDown, FunctorUp &FUp);
};
EXPORT
template<class Int, class Functor, class FunctorDown, class FunctorUp>
class ForAllPBCM3Down{
 public:
void operator()(Index3dBase<Int> const &ind, 
		Functor &F, FunctorDown &FDown, FunctorUp &FUp);
};


EXPORT
template<class Int, class Functor, class FunctorDown, class FunctorUp>
class ForAllMore{
 public:
void operator()(Index3dBase<Int> const &ind, 
		Functor &F, FunctorDown &FDown, FunctorUp &FUp);
};
EXPORT
template<class Int, class Functor, class FunctorDown, class FunctorUp>
class ForAllEvenMore{
 public:
void operator()(Index3dBase<Int> const &ind, 
		Functor &F, FunctorDown &FDown, FunctorUp &FUp);
};

EXPORT
template<class Int, class Functor, class FunctorDown, class FunctorUp>
class ForAllColumnwiseM2Up
{
 public:
void operator()(Index3dBase<Int> const &ind, 
		Functor &F, FunctorDown &FDown, FunctorUp &FUp);
};


EXPORT
template<class Int, class Functor, class FunctorDown, class FunctorUp>
class ForAllColumnwiseM2Down{
 public:
void operator()(Index3dBase<Int> const &ind, 
		Functor &F, FunctorDown &FDown, FunctorUp &FUp);
};

EXPORT
template<class Int, class Functor, class FunctorDown, class FunctorUp>
class ForAllColumnwiseM4Up
{
 public:
void operator()(Index3dBase<Int> const &ind, 
		Functor &F, FunctorDown &FDown, FunctorUp &FUp);
};

EXPORT
template<class Int, class Functor, class FunctorDown, class FunctorUp>
class ForAllColumnwise
{
 public:
void operator()(Index3dBase<Int> const &ind, 
		Functor &F, FunctorDown &FDown, FunctorUp &FUp);
};

EXPORT
template<class Int, class Functor, class FunctorDown, class FunctorUp>
class ForAllColumnwiseReverse{
 public:
void operator()(Index3dBase<Int> const &ind, 
		Functor &F, FunctorDown &FDown, FunctorUp &FUp);
};

EXPORT
template<class Int, class Functor, class FunctorDown, class FunctorUp>
class ForAllColumnwiseM4Down{
public:
void operator()(Index3dBase<Int> const &ind, 
		Functor &F, FunctorDown &FDown, FunctorUp &FUp);
};

EXPORT
template<class Int, class Functor>
void ForAllMiddle(Index3dBase<Int> const &ind,
		  Functor &F);
EXPORT
template<class Int, class Functor>
void ForAllNonMiddle(Index3dBase<Int> const &ind,
		     Functor &F);
EXPORT
template<class Int, class Functor>
void DoForEach(Index3dBase<Int> const &ind, 
	       Functor &F, bool dolast=true, Int m1=0);
EXPORT
template<class Int, class Functor>
void DoForEachSpecial(Index3dBase<Int> const &ind, 
		      Functor &F, bool dolast=true);
EXPORT
template<class Int, class Functor>
void DoForEachSpecial3(Index3dBase<Int> const &ind, 
		       Functor &F, bool dolast=true);

EXPORT
template<class Int, class Functor>
void DoForEachSpecial2(Index3dBase<Int> const &ind, 
		       Functor &F, bool dolast=true);
EXPORT
template<class Int, class Functor>
void DoForEachSpecialReverse(Index3dBase<Int> const &ind,
			     Functor &F, bool dolast=true);
EXPORT
template<class Int, class Functor>
void DoForEachExtra(Index3dBase<Int> const &ind, Functor &F);
EXPORT
template<class Int, class Functor>
void CDoForEach(Index3dBase<Int> const &ind, Functor &F);
EXPORT
template<class Int, class Functor>
void DoForEachReverse(Index3dBase<Int> const &ind, Functor &F);
EXPORT
template<class Int, class Functor>
void CDoForEachReverse(Index3dBase<Int> const &ind, Functor &F);

#ifndef USE_EXPORT
#include "visitors.hpp" //we should include this..
#endif

#endif
#ifdef INCLUSION
#include "visitors.hpp"
#endif
